/* This file is part of mailfrom filter.             -*- c -*-
   Copyright (C) 2006 Sergey Poznyakoff

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
   MA 02110-1301 USA */

MF_VAR(rcpt_count, NUMBER);
MF_VAR(ehlo_domain, STRING);
MF_VAR(mailfrom_address, STRING);

/* Functions to access %rcpt_count */
unsigned long
get_rcpt_count(eval_environ_t env)
{
	return (long) MF_VAR_REF(rcpt_count);
}

void
clear_rcpt_count(eval_environ_t env)
{
	MF_VAR_REF(rcpt_count, 0);
}

void
incr_rcpt_count(eval_environ_t env)
{
	MF_VAR_INC(rcpt_count);
}

void
builtin_post_setup()
{
	if (!smtp_domain)
		mu_get_host_name(&smtp_domain);
	if (!variable_declared_p("ehlo_domain"))
		declare_variable("ehlo_domain",
				 ehlo_domain_loc, smtp_domain);
	if (!variable_declared_p("mailfrom_address"))
		declare_variable("mailfrom_address",
				 mailfrom_address_loc,
				 postmaster_email);
}

MF_INIT(vars)
